<!DOCTYPE HTML>
<html>
<head>
    <style>
        @page {
            width: 100%;
            height: 100%;
            margin: 2mm;
        }
        table {
            width: 100%;
            height: 100%;
        }
        td {
            width: 50mm;
        }
        img {
            margin: auto;
            display: block;
            width: 50mm;
            height: 25mm;
        }
        .page-break {
            page-break-after: always;
        }
    </style>

</head>
<body>
{% set rows = 10 %}
{% set cols = 4 %}
{% set pages = (quantity / (rows * cols))|round(method="ceil")|int %}

{% for page in range(pages) %}
    <table>
        <tbody>
            {% for row in range(rows) %}
                <tr>
                    {% for col in range(cols) %}
                        <td>
                            {% set index = page*rows*cols + row*cols + col %}
                            {% if index < quantity %}
                                <img src="{{ barcode_url }}">
                                {% else %}
                            {% endif %}
                        </td>
                    {% endfor %}
                </tr>
            {% endfor %}
        </tbody>
    </table>
    {% if not loop.last %}
        <p class="page-break"></p>
    {% endif %}
{% endfor %}
</body>
</html>
